#include "otaEvent.h"
#include "usart.h"
#include "systick.h"
#include "w25q32.h"
#include "main.h"
#include "ec800m.h"
#include <stdio.h>
#include "string.h"

#define APPBLOCKNB 2      	//صĳλblockĵ3
#define OTA_EVENT_BLOCKNB 1 //OTA¼ɱ־洢λλڵ2

#define SOH 0x01 // XMODЭ֡ͷ
#define ACK 0X06 // Ӧ־
#define NAK 0x15 // Ӧ־
#define EOT 0x04 // ־
int8_t xmodem(uint16_t timeout);
OTA_T ota_data;
uint16_t Xmodem_CRC16(uint8_t *data, uint16_t datalen);
/*
 *  uint8_t check_ota_event()
 *  
 *  
 *  ֵ
 *  ãжota¼ǷǷҪ²
 */
int8_t check_ota_event()
{
	                                           //رտŹ
	// ־λΪ1ʱ֤ota¼,ota·
	if (ota_data.ota_flag == 1)
	{
		// W25Q32_Erase64K(APPBLOCKNB);                    //ļڵblockԺ
		EC800MSendCmd(DEL_otaDATA_FILE, strlen(DEL_otaDATA_FILE));	//OTAļ
		int8_t recvSta = xmodem(1000);						//1000ڽOTA
		if (recvSta == 0)
		{
			return 0;
		}
		else  
		{
			NVIC_SystemReset();
		}
	}
	else
		return 0;
}

uint8_t WaitResponse_value(int timeout)
{
	bool timeoutFlag = false;
	if (timeout >= 0)
	{
		timeoutFlag = true;
	}

	while (1)
	{
		delay_1ms(50);
		if (UART0_RX_STAT > 0)
		{
			UART0_RX_STAT = 0;
			char *p = strstr((char *)&UART0_RX_BUF, ": ") + 2;
			if (p)
			{
				uint8_t ret = 0;
				ret = strtol(p, &p, 10);
				Clear_DMA_Buffer();
				return ret;
			}
		}
		timeout -= 50;
		if (timeoutFlag == true && timeout <= 0)
		{
			Clear_DMA_Buffer();
			return 0;
		}
	};
}

int8_t xmodem(uint16_t timeout)
{
	int startTime = gettick();
	ota_data.done=0;
	OTA_flag data_flag;
	data_flag.flag=0;
	data_flag.xmodemNB=0;                         
	while(1)
	{
		task_fwdgt_reload();                                 //ι
		if(gettick()-startTime>timeout*1000)return 0;		//һֱòλxmodeӦʱ
		usart_data_transmit(COM_232, 'C');					//λ'C'xmodem
		delay_1ms(1000);
		if(ota_data.done==1)
		{
			//otaMSG.txtļ
			EC800MSendCmd(OPEN_otaDATA_FILE,strlen(OPEN_otaDATA_FILE));
			if(WaitResponse("QFOPEN:", 2000) == 0)
				return 0;
			break;							//λӦѭȴ
		}
	}
	// ж֡ͷǷϱ׼
	while (gettick() - startTime < timeout * 1000)
	{
		if (ota_data.done == 1)
		{
			task_fwdgt_reload();                                       //ι
			if (ota_data.data[0] == SOH && ota_data.data_cnt == 133)	//xmodemݰ128ֽ
			{
				uint16_t XCRC = Xmodem_CRC16(ota_data.data + 3, 128);	
				if (XCRC == ota_data.data[131] * 256 + ota_data.data[132]) // Уһʱݴ
				{
					data_flag.xmodemNB++;	//xmodemݰ
					// W25Q32_PageWrite(w25q32_data,APPBLOCKNB*256+(data_flag.xmodemNB-1)/2);
					uint8_t sed_flg = 0;
					while(sed_flg < 2)
					{
						EC800MSendCmd(WRITE_otaDATA_FILE,strlen(WRITE_otaDATA_FILE));
						if(WaitResponse("CONNECT", 2000) == 0)
						{
							sed_flg++;
						}
						else
						{
							sed_flg = 0;
							break;
						}	
					}
					while(sed_flg < 2)
					{
						EC800MSendCmd(ota_data.data + 3,128);
						int x = WaitResponse_value(2000);
						if(x != 128)
						{
							sed_flg++;
							char* QFSEEK_CMD;
							sprintf(QFSEEK_CMD,"AT+QFSEEK=1,%d,2",x);
							EC800MSendCmd(QFSEEK_CMD,strlen(QFSEEK_CMD));	//Ļļָƫxֽ
						}
						else
						{
							sed_flg = 0;
							break;
						}
					}
					
					ota_data.data_cnt = 0;
					memset(ota_data.data, 0, 133);
					ota_data.done = 0;
					usart_data_transmit(COM_232, ACK);
	
				}
				else
				{
					ota_data.data_cnt = 0;
					memset(ota_data.data, 0, 133);
					ota_data.done = 0;
					usart_data_transmit(COM_232, NAK);
				}
			}
			//İ
			else if (ota_data.data[0] == EOT && ota_data.data_cnt == 1)
			{
				// if(data_flag.xmodemNB%2!=0)                                            //Ϊдȥ
				// {
					// W25Q32_PageWrite(w25q32_data,APPBLOCKNB*256+(data_flag.xmodemNB-1)/2);
				// }
				// UFSļ
				uint8_t sed_flg = 0;
				while(sed_flg < 2)
				{
					EC800MSendCmd(CLOSE_otaDATA_FILE,strlen(CLOSE_otaDATA_FILE));
					if(WaitResponse("OK", 2000) == 0)
					{
						sed_flg++;
					}
					else
					{
						sed_flg = 0;
						break;
					}	
				}

				usart_data_transmit(COM_232, ACK);
				//xmodemЭĽɵı־洢ڴ
				OTA_MESSAGE ota_message;
				ota_message.Completion_flag=1U;
				ota_message.XmodemByte=data_flag.xmodemNB*128;//0x1AҪһ

				while(sed_flg < 2)
				{
					EC800MSendCmd(OPEN_otaMSG_FILE,strlen(OPEN_otaMSG_FILE));
					if(WaitResponse("QFOPEN:", 2000) == 0)
					{
						sed_flg++;
					}
					else
					{
						sed_flg = 0;
						break;
					}
				}
				

				while(sed_flg < 2)
				{
					EC800MSendCmd(WRITE_otaMSG_FILE,strlen(WRITE_otaMSG_FILE));
					if(WaitResponse("CONNECT", 2000) == 0)
					{
						sed_flg++;
					}
					else
					{
						sed_flg = 0;
						break;
					}
				}

				while(sed_flg < 2)
				{
					EC800MSendCmd((uint8_t *)&ota_message,sizeof(OTA_MESSAGE));
					int x = WaitResponse_value(2000);
					if(x != sizeof(OTA_MESSAGE))
					{
						sed_flg++;
						char* QFSEEK_CMD;
						sprintf(QFSEEK_CMD,"AT+QFSEEK=1,%d,2",x);
						EC800MSendCmd(QFSEEK_CMD,strlen(QFSEEK_CMD));	//Ļļָƫxֽ
					}
					else
					{
						sed_flg = 0;
						break;
					}
				}

				while(sed_flg < 2)
				{
					EC800MSendCmd(CLOSE_otaMSG_FILE,strlen(CLOSE_otaMSG_FILE));
					if(WaitResponse("OK", 2000))
					{
						sed_flg++;
					}
					else
					{
						sed_flg = 0;
						break;
					}
				}

				// W25Q32_Erase64K(OTA_EVENT_BLOCKNB);//ԭȵ
				// W25Q32_PageWrite((uint8_t *)&ota_message,OTA_EVENT_BLOCKNB*256);
			
				delay_1ms(50);
				// д¼ɱ־豸,״̬ҳعдɻִָ
				return 1;
			}
			else
			{
				ota_data.data_cnt = 0;
				memset(ota_data.data, 0, 133);
				ota_data.done = 0;
				usart_data_transmit(COM_232, NAK);
			}
		}

		delay_1ms(1);
	}
	return 0;
}

/*-------------------------------------------------*/
/*Xmodem_CRC16У                         */
/*  dataָ  datalenݳ        */
/*ֵУ                             */
/*-------------------------------------------------*/
uint16_t Xmodem_CRC16(uint8_t *data, uint16_t datalen)
{

	uint8_t i;					// forѭ
	uint16_t Crcinit = 0x0000;	// Xmdoem CRCУĳʼֵ0x0000
	uint16_t Crcipoly = 0x1021; // Xmdoem CRCУĶʽ0x1021

	while (datalen--)
	{									  // datalenСжֽѭٴ
		Crcinit = (*data << 8) ^ Crcinit; // ȽУֽڣŲ8λ
		for (i = 0; i < 8; i++)
		{											 // ÿֽ8λѭ8
			if (Crcinit & 0x8000)					 // жBIT1510,1Ļif
				Crcinit = (Crcinit << 1) ^ Crcipoly; // 1Ļƣʽ
			else									 // жBIT1510,0Ļelse
				Crcinit = (Crcinit << 1);			 // 0Ļֻ
		}
		data++; // ƣһֽ
	}
	return Crcinit; // У
}
